<?php

/**
 * Migration tool from 5.2 to 5.3.
 *
 * This file is part of the Nette Framework (http://nette.org)
 * @phpversion 5.3
 */

require __DIR__ . '/../../Nette-minified/nette.min.php';


$options = getopt('d:f');

if (!$options) { ?>

Migrate53 helps you with the migration from PHP 5.2 to PHP 5.3 package
of Nette Framework. It prepends namespaces to Nette Framework class names
used in your source code.

Usage: php migrate-53.php [options]

Options:
	-d <path>  folder to scan (optional)
	-f         fixes files

<?php
}



class ClassUpdater extends Nette\Object
{
	public $readOnly = FALSE;

	public $replaces = array(
		'ambiguousserviceexception' => 'Nette\DI\AmbiguousServiceException',
		'nambiguousserviceexception' => 'Nette\DI\AmbiguousServiceException',
		'abortexception' => 'Nette\Application\AbortException',
		'nabortexception' => 'Nette\Application\AbortException',
		'appform' => 'Nette\Application\UI\Form',
		'nappform' => 'Nette\Application\UI\Form',
		'application' => 'Nette\Application\Application',
		'napplication' => 'Nette\Application\Application',
		'applicationexception' => 'Nette\Application\ApplicationException',
		'napplicationexception' => 'Nette\Application\ApplicationException',
		'badrequestexception' => 'Nette\Application\BadRequestException',
		'nbadrequestexception' => 'Nette\Application\BadRequestException',
		'badsignalexception' => 'Nette\Application\UI\BadSignalException',
		'nbadsignalexception' => 'Nette\Application\UI\BadSignalException',
		'clirouter' => 'Nette\Application\Routers\CliRouter',
		'nclirouter' => 'Nette\Application\Routers\CliRouter',
		'control' => 'Nette\Application\UI\Control',
		'ncontrol' => 'Nette\Application\UI\Control',
		'forbiddenrequestexception' => 'Nette\Application\ForbiddenRequestException',
		'nforbiddenrequestexception' => 'Nette\Application\ForbiddenRequestException',
		'ipartiallyrenderable' => 'Nette\Application\UI\IPartiallyRenderable',
		'ipresenter' => 'Nette\Application\IPresenter',
		'ipresenterresponse' => 'Nette\Application\IResponse',
		'irenderable' => 'Nette\Application\UI\IRenderable',
		'irouter' => 'Nette\Application\IRouter',
		'isignalreceiver' => 'Nette\Application\UI\ISignalReceiver',
		'istatepersistent' => 'Nette\Application\UI\IStatePersistent',
		'invalidlinkexception' => 'Nette\Application\UI\InvalidLinkException',
		'ninvalidlinkexception' => 'Nette\Application\UI\InvalidLinkException',
		'invalidpresenterexception' => 'Nette\Application\InvalidPresenterException',
		'ninvalidpresenterexception' => 'Nette\Application\InvalidPresenterException',
		'jsonresponse' => 'Nette\Application\Responses\JsonResponse',
		'njsonresponse' => 'Nette\Application\Responses\JsonResponse',
		'link' => 'Nette\Application\UI\Link',
		'nlink' => 'Nette\Application\UI\Link',
		'presenter' => 'Nette\Application\UI\Presenter',
		'npresenter' => 'Nette\Application\UI\Presenter',
		'presentercomponent' => 'Nette\Application\UI\PresenterComponent',
		'npresentercomponent' => 'Nette\Application\UI\PresenterComponent',
		'presentercomponentreflection' => 'Nette\Application\UI\PresenterComponentReflection',
		'npresentercomponentreflection' => 'Nette\Application\UI\PresenterComponentReflection',
		'presenterrequest' => 'Nette\Application\Request',
		'npresenterrequest' => 'Nette\Application\Request',
		'route' => 'Nette\Application\Routers\Route',
		'nroute' => 'Nette\Application\Routers\Route',
		'simplerouter' => 'Nette\Application\Routers\SimpleRouter',
		'nsimplerouter' => 'Nette\Application\Routers\SimpleRouter',
		'cache' => 'Nette\Caching\Cache',
		'ncache' => 'Nette\Caching\Cache',
		'filestorage' => 'Nette\Caching\Storages\FileStorage',
		'nfilestorage' => 'Nette\Caching\Storages\FileStorage',
		'icachestorage' => 'Nette\Caching\IStorage',
		'memcachedstorage' => 'Nette\Caching\Storages\MemcachedStorage',
		'nmemcachedstorage' => 'Nette\Caching\Storages\MemcachedStorage',
		'callback' => 'Nette\Callback',
		'ncallback' => 'Nette\Callback',
		'arraylist' => 'Nette\ArrayList',
		'narraylist' => 'Nette\ArrayList',
		'component' => 'Nette\ComponentModel\Component',
		'ncomponent' => 'Nette\ComponentModel\Component',
		'componentcontainer' => 'Nette\ComponentModel\Container',
		'ncomponentcontainer' => 'Nette\ComponentModel\Container',
		'config' => 'Nette\Config\Config',
		'nconfig' => 'Nette\Config\Config',
		'configadapterini' => 'Nette\Config\IniAdapter',
		'nconfigadapterini' => 'Nette\Config\IniAdapter',
		'iconfigadapter' => 'Nette\Config\IAdapter',
		'configurator' => 'Nette\Configurator',
		'nconfigurator' => 'Nette\Configurator',
		'datetime53' => 'Nette\DateTime',
		'ndatetime53' => 'Nette\DateTime',
		'environment' => 'Nette\Environment',
		'nenvironment' => 'Nette\Environment',
		'button' => 'Nette\Forms\Controls\Button',
		'nbutton' => 'Nette\Forms\Controls\Button',
		'checkbox' => 'Nette\Forms\Controls\Checkbox',
		'ncheckbox' => 'Nette\Forms\Controls\Checkbox',
		'form' => 'Nette\Forms\Form',
		'nform' => 'Nette\Forms\Form',
		'formcontainer' => 'Nette\Forms\Container',
		'nformcontainer' => 'Nette\Forms\Container',
		'formcontrol' => 'Nette\Forms\Controls\BaseControl',
		'nformcontrol' => 'Nette\Forms\Controls\BaseControl',
		'formgroup' => 'Nette\Forms\ControlGroup',
		'nformgroup' => 'Nette\Forms\ControlGroup',
		'hiddenfield' => 'Nette\Forms\Controls\HiddenField',
		'nhiddenfield' => 'Nette\Forms\Controls\HiddenField',
		'iformcontrol' => 'Nette\Forms\IControl',
		'iformrenderer' => 'Nette\Forms\IFormRenderer',
		'isubmittercontrol' => 'Nette\Forms\ISubmitterControl',
		'imagebutton' => 'Nette\Forms\Controls\ImageButton',
		'nimagebutton' => 'Nette\Forms\Controls\ImageButton',
		'multiselectbox' => 'Nette\Forms\Controls\MultiSelectBox',
		'nmultiselectbox' => 'Nette\Forms\Controls\MultiSelectBox',
		'radiolist' => 'Nette\Forms\Controls\RadioList',
		'nradiolist' => 'Nette\Forms\Controls\RadioList',
		'rule' => 'Nette\Forms\Rule',
		'nrule' => 'Nette\Forms\Rule',
		'rules' => 'Nette\Forms\Rules',
		'nrules' => 'Nette\Forms\Rules',
		'selectbox' => 'Nette\Forms\Controls\SelectBox',
		'nselectbox' => 'Nette\Forms\Controls\SelectBox',
		'submitbutton' => 'Nette\Forms\Controls\SubmitButton',
		'nsubmitbutton' => 'Nette\Forms\Controls\SubmitButton',
		'textarea' => 'Nette\Forms\Controls\TextArea',
		'ntextarea' => 'Nette\Forms\Controls\TextArea',
		'textbase' => 'Nette\Forms\Controls\TextBase',
		'ntextbase' => 'Nette\Forms\Controls\TextBase',
		'textinput' => 'Nette\Forms\Controls\TextInput',
		'ntextinput' => 'Nette\Forms\Controls\TextInput',
		'framework' => 'Nette\Framework',
		'nframework' => 'Nette\Framework',
		'freezableobject' => 'Nette\FreezableObject',
		'nfreezableobject' => 'Nette\FreezableObject',
		'genericrecursiveiterator' => 'Nette\Iterators\Recursor',
		'ngenericrecursiveiterator' => 'Nette\Iterators\Recursor',
		'icomponent' => 'Nette\ComponentModel\IComponent',
		'icomponentcontainer' => 'Nette\ComponentModel\IContainer',
		'safestream' => 'Nette\Utils\SafeStream',
		'nsafestream' => 'Nette\Utils\SafeStream',
		'itranslator' => 'Nette\Localization\ITranslator',
		'image' => 'Nette\Image',
		'nimage' => 'Nette\Image',
		'instancefilteriterator' => 'Nette\Iterators\InstanceFilter',
		'ninstancefilteriterator' => 'Nette\Iterators\InstanceFilter',
		'autoloader' => 'Nette\Loaders\AutoLoader',
		'nautoloader' => 'Nette\Loaders\AutoLoader',
		'limitedscope' => 'Nette\Utils\LimitedScope',
		'nlimitedscope' => 'Nette\Utils\LimitedScope',
		'netteloader' => 'Nette\Loaders\NetteLoader',
		'nnetteloader' => 'Nette\Loaders\NetteLoader',
		'robotloader' => 'Nette\Loaders\RobotLoader',
		'nrobotloader' => 'Nette\Loaders\RobotLoader',
		'imailer' => 'Nette\Mail\IMailer',
		'mail' => 'Nette\Mail\Message',
		'nmail' => 'Nette\Mail\Message',
		'mailmimepart' => 'Nette\Mail\MimePart',
		'nmailmimepart' => 'Nette\Mail\MimePart',
		'sendmailmailer' => 'Nette\Mail\SendmailMailer',
		'nsendmailmailer' => 'Nette\Mail\SendmailMailer',
		'object' => 'Nette\Object',
		'nobject' => 'Nette\Object',
		'objectmixin' => 'Nette\ObjectMixin',
		'nobjectmixin' => 'Nette\ObjectMixin',
		'paginator' => 'Nette\Utils\Paginator',
		'npaginator' => 'Nette\Utils\Paginator',
		'recursivecomponentiterator' => 'Nette\ComponentModel\RecursiveComponentIterator',
		'nrecursivecomponentiterator' => 'Nette\ComponentModel\RecursiveComponentIterator',
		'annotation' => 'Nette\Reflection\Annotation',
		'nannotation' => 'Nette\Reflection\Annotation',
		'annotationsparser' => 'Nette\Reflection\AnnotationsParser',
		'nannotationsparser' => 'Nette\Reflection\AnnotationsParser',
		'classreflection' => 'Nette\Reflection\ClassType',
		'nclassreflection' => 'Nette\Reflection\ClassType',
		'extensionreflection' => 'Nette\Reflection\Extension',
		'nextensionreflection' => 'Nette\Reflection\Extension',
		'functionreflection' => 'Nette\Reflection\GlobalFunction',
		'nfunctionreflection' => 'Nette\Reflection\GlobalFunction',
		'iannotation' => 'Nette\Reflection\IAnnotation',
		'methodreflection' => 'Nette\Reflection\Method',
		'nmethodreflection' => 'Nette\Reflection\Method',
		'parameterreflection' => 'Nette\Reflection\Parameter',
		'nparameterreflection' => 'Nette\Reflection\Parameter',
		'propertyreflection' => 'Nette\Reflection\Property',
		'npropertyreflection' => 'Nette\Reflection\Property',
		'authenticationexception' => 'Nette\Security\AuthenticationException',
		'nauthenticationexception' => 'Nette\Security\AuthenticationException',
		'iauthenticator' => 'Nette\Security\IAuthenticator',
		'iauthorizator' => 'Nette\Security\IAuthorizator',
		'iidentity' => 'Nette\Security\IIdentity',
		'iresource' => 'Nette\Security\IResource',
		'irole' => 'Nette\Security\IRole',
		'identity' => 'Nette\Security\Identity',
		'nidentity' => 'Nette\Security\Identity',
		'permission' => 'Nette\Security\Permission',
		'npermission' => 'Nette\Security\Permission',
		'simpleauthenticator' => 'Nette\Security\SimpleAuthenticator',
		'nsimpleauthenticator' => 'Nette\Security\SimpleAuthenticator',
		'smartcachingiterator' => 'Nette\Iterators\CachingIterator',
		'nsmartcachingiterator' => 'Nette\Iterators\CachingIterator',
		'cachinghelper' => 'Nette\Caching\OutputHelper',
		'ncachinghelper' => 'Nette\Caching\OutputHelper',
		'ifiletemplate' => 'Nette\Templating\IFileTemplate',
		'itemplate' => 'Nette\Templating\ITemplate',
		'lattefilter' => 'Nette\Latte\Engine',
		'nlattefilter' => 'Nette\Latte\Engine',
		'template' => 'Nette\Templating\Template',
		'ntemplate' => 'Nette\Templating\Template',
		'templatehelpers' => 'Nette\Templating\DefaultHelpers',
		'ntemplatehelpers' => 'Nette\Templating\DefaultHelpers',
		'html' => 'Nette\Utils\Html',
		'nhtml' => 'Nette\Utils\Html',
		'httpcontext' => 'Nette\Http\Context',
		'nhttpcontext' => 'Nette\Http\Context',
		'httprequest' => 'Nette\Http\Request',
		'nhttprequest' => 'Nette\Http\Request',
		'httpresponse' => 'Nette\Http\Response',
		'nhttpresponse' => 'Nette\Http\Response',
		'httpuploadedfile' => 'Nette\Http\FileUpload',
		'nhttpuploadedfile' => 'Nette\Http\FileUpload',
		'ihttprequest' => 'Nette\Http\IRequest',
		'ihttpresponse' => 'Nette\Http\IResponse',
		'session' => 'Nette\Http\Session',
		'nsession' => 'Nette\Http\Session',
		'user' => 'Nette\Security\User',
		'nuser' => 'Nette\Security\User',
		'ipresenterfactory' => 'Nette\Application\IPresenterFactory',
		'presenterfactory' => 'Nette\Application\PresenterFactory',
		'npresenterfactory' => 'Nette\Application\PresenterFactory',
		'routingdebugger' => 'Nette\Application\Diagnostics\RoutingPanel',
		'nroutingdebugger' => 'Nette\Application\Diagnostics\RoutingPanel',
		'arrayhash' => 'Nette\ArrayHash',
		'narrayhash' => 'Nette\ArrayHash',
		'filejournal' => 'Nette\Caching\Storages\FileJournal',
		'nfilejournal' => 'Nette\Caching\Storages\FileJournal',
		'icachejournal' => 'Nette\Caching\Storages\IJournal',
		'memorystorage' => 'Nette\Caching\Storages\MemoryStorage',
		'nmemorystorage' => 'Nette\Caching\Storages\MemoryStorage',
		'callbackfilteriterator' => 'Nette\Iterators\Filter',
		'ncallbackfilteriterator' => 'Nette\Iterators\Filter',
		'configadapterneon' => 'Nette\Config\NeonAdapter',
		'nconfigadapterneon' => 'Nette\Config\NeonAdapter',
		'criticalsection' => 'Nette\Utils\CriticalSection',
		'ncriticalsection' => 'Nette\Utils\CriticalSection',
		'connection' => 'Nette\Database\Connection',
		'nconnection' => 'Nette\Database\Connection',
		'databasepanel' => 'Nette\Database\Diagnostics\ConnectionPanel',
		'ndatabasepanel' => 'Nette\Database\Diagnostics\ConnectionPanel',
		'isupplementaldriver' => 'Nette\Database\ISupplementalDriver',
		'databasereflection' => 'Nette\Database\Reflection\DatabaseReflection',
		'ndatabasereflection' => 'Nette\Database\Reflection\DatabaseReflection',
		'row' => 'Nette\Database\Row',
		'nrow' => 'Nette\Database\Row',
		'groupedtableselection' => 'Nette\Database\Table\GroupedSelection',
		'ngroupedtableselection' => 'Nette\Database\Table\GroupedSelection',
		'tablerow' => 'Nette\Database\Table\ActiveRow',
		'ntablerow' => 'Nette\Database\Table\ActiveRow',
		'tableselection' => 'Nette\Database\Table\Selection',
		'ntableselection' => 'Nette\Database\Table\Selection',
		'sqlliteral' => 'Nette\Database\SqlLiteral',
		'nsqlliteral' => 'Nette\Database\SqlLiteral',
		'sqlpreprocessor' => 'Nette\Database\SqlPreprocessor',
		'nsqlpreprocessor' => 'Nette\Database\SqlPreprocessor',
		'statement' => 'Nette\Database\Statement',
		'nstatement' => 'Nette\Database\Statement',
		'debughelpers' => 'Nette\Diagnostics\Helpers',
		'ndebughelpers' => 'Nette\Diagnostics\Helpers',
		'finder' => 'Nette\Utils\Finder',
		'nfinder' => 'Nette\Utils\Finder',
		'defaultformrenderer' => 'Nette\Forms\Rendering\DefaultFormRenderer',
		'ndefaultformrenderer' => 'Nette\Forms\Rendering\DefaultFormRenderer',
		'ifreezable' => 'Nette\IFreezable',
		'json' => 'Nette\Utils\Json',
		'njson' => 'Nette\Utils\Json',
		'jsonexception' => 'Nette\Utils\JsonException',
		'njsonexception' => 'Nette\Utils\JsonException',
		'smtpexception' => 'Nette\Mail\SmtpException',
		'nsmtpexception' => 'Nette\Mail\SmtpException',
		'smtpmailer' => 'Nette\Mail\SmtpMailer',
		'nsmtpmailer' => 'Nette\Mail\SmtpMailer',
		'mapiterator' => 'Nette\Iterators\Mapper',
		'nmapiterator' => 'Nette\Iterators\Mapper',
		'mimetypedetector' => 'Nette\Utils\MimeTypeDetector',
		'nmimetypedetector' => 'Nette\Utils\MimeTypeDetector',
		'neon' => 'Nette\Utils\Neon',
		'nneon' => 'Nette\Utils\Neon',
		'neonexception' => 'Nette\Utils\NeonException',
		'nneonexception' => 'Nette\Utils\NeonException',
		'recursivecallbackfilteriterator' => 'Nette\Iterators\RecursiveFilter',
		'nrecursivecallbackfilteriterator' => 'Nette\Iterators\RecursiveFilter',
		'regexpexception' => 'Nette\Utils\RegexpException',
		'nregexpexception' => 'Nette\Utils\RegexpException',
		'filetemplate' => 'Nette\Templating\FileTemplate',
		'nfiletemplate' => 'Nette\Templating\FileTemplate',
		'latteexception' => 'Nette\Latte\ParseException',
		'nlatteexception' => 'Nette\Latte\ParseException',
		'templateexception' => 'Nette\Templating\FilterException',
		'ntemplateexception' => 'Nette\Templating\FilterException',
		'tokenizer' => 'Nette\Utils\Tokenizer',
		'ntokenizer' => 'Nette\Utils\Tokenizer',
		'tokenizerexception' => 'Nette\Utils\TokenizerException',
		'ntokenizerexception' => 'Nette\Utils\TokenizerException',
		'httprequestfactory' => 'Nette\Http\RequestFactory',
		'nhttprequestfactory' => 'Nette\Http\RequestFactory',
		'isessionstorage' => 'Nette\Http\ISessionStorage',
		'micropresenter' => 'NetteModule\MicroPresenter',
		'nmicropresenter' => 'NetteModule\MicroPresenter',
		'fileresponse' => 'Nette\Application\Responses\FileResponse',
		'nfileresponse' => 'Nette\Application\Responses\FileResponse',
		'forwardresponse' => 'Nette\Application\Responses\ForwardResponse',
		'nforwardresponse' => 'Nette\Application\Responses\ForwardResponse',
		'redirectresponse' => 'Nette\Application\Responses\RedirectResponse',
		'nredirectresponse' => 'Nette\Application\Responses\RedirectResponse',
		'textresponse' => 'Nette\Application\Responses\TextResponse',
		'ntextresponse' => 'Nette\Application\Responses\TextResponse',
		'routelist' => 'Nette\Application\Routers\RouteList',
		'nroutelist' => 'Nette\Application\Routers\RouteList',
		'argumentoutofrangeexception' => 'Nette\ArgumentOutOfRangeException',
		'nargumentoutofrangeexception' => 'Nette\ArgumentOutOfRangeException',
		'devnullstorage' => 'Nette\Caching\Storages\DevNullStorage',
		'ndevnullstorage' => 'Nette\Caching\Storages\DevNullStorage',
		'phpfilestorage' => 'Nette\Caching\Storages\PhpFileStorage',
		'nphpfilestorage' => 'Nette\Caching\Storages\PhpFileStorage',
		'dicontainer' => 'Nette\DI\Container',
		'ndicontainer' => 'Nette\DI\Container',
		'containerbuilder' => 'Nette\DI\ContainerBuilder',
		'ncontainerbuilder' => 'Nette\DI\ContainerBuilder',
		'idicontainer' => 'Nette\DI\IContainer',
		'iservicebuilder' => 'Nette\DI\IServiceBuilder',
		'missingserviceexception' => 'Nette\DI\MissingServiceException',
		'nmissingserviceexception' => 'Nette\DI\MissingServiceException',
		'servicebuilder' => 'Nette\DI\ServiceBuilder',
		'nservicebuilder' => 'Nette\DI\ServiceBuilder',
		'mssqldriver' => 'Nette\Database\Drivers\MsSqlDriver',
		'nmssqldriver' => 'Nette\Database\Drivers\MsSqlDriver',
		'mysqldriver' => 'Nette\Database\Drivers\MySqlDriver',
		'nmysqldriver' => 'Nette\Database\Drivers\MySqlDriver',
		'ocidriver' => 'Nette\Database\Drivers\OciDriver',
		'nocidriver' => 'Nette\Database\Drivers\OciDriver',
		'odbcdriver' => 'Nette\Database\Drivers\OdbcDriver',
		'nodbcdriver' => 'Nette\Database\Drivers\OdbcDriver',
		'pgsqldriver' => 'Nette\Database\Drivers\PgSqlDriver',
		'npgsqldriver' => 'Nette\Database\Drivers\PgSqlDriver',
		'sqlite2driver' => 'Nette\Database\Drivers\Sqlite2Driver',
		'nsqlite2driver' => 'Nette\Database\Drivers\Sqlite2Driver',
		'sqlitedriver' => 'Nette\Database\Drivers\SqliteDriver',
		'nsqlitedriver' => 'Nette\Database\Drivers\SqliteDriver',
		'deprecatedexception' => 'Nette\DeprecatedException',
		'ndeprecatedexception' => 'Nette\DeprecatedException',
		'debugbar' => 'Nette\Diagnostics\Bar',
		'ndebugbar' => 'Nette\Diagnostics\Bar',
		'debugbluescreen' => 'Nette\Diagnostics\BlueScreen',
		'ndebugbluescreen' => 'Nette\Diagnostics\BlueScreen',
		'debugger' => 'Nette\Diagnostics\Debugger',
		'ndebugger' => 'Nette\Diagnostics\Debugger',
		'defaultbarpanel' => 'Nette\Diagnostics\DefaultBarPanel',
		'ndefaultbarpanel' => 'Nette\Diagnostics\DefaultBarPanel',
		'firelogger' => 'Nette\Diagnostics\FireLogger',
		'nfirelogger' => 'Nette\Diagnostics\FireLogger',
		'ibarpanel' => 'Nette\Diagnostics\IBarPanel',
		'logger' => 'Nette\Diagnostics\Logger',
		'nlogger' => 'Nette\Diagnostics\Logger',
		'directorynotfoundexception' => 'Nette\DirectoryNotFoundException',
		'ndirectorynotfoundexception' => 'Nette\DirectoryNotFoundException',
		'fatalerrorexception' => 'Nette\FatalErrorException',
		'nfatalerrorexception' => 'Nette\FatalErrorException',
		'filenotfoundexception' => 'Nette\FileNotFoundException',
		'nfilenotfoundexception' => 'Nette\FileNotFoundException',
		'uploadcontrol' => 'Nette\Forms\Controls\UploadControl',
		'nuploadcontrol' => 'Nette\Forms\Controls\UploadControl',
		'sessionsection' => 'Nette\Http\SessionSection',
		'nsessionsection' => 'Nette\Http\SessionSection',
		'url' => 'Nette\Http\Url',
		'nurl' => 'Nette\Http\Url',
		'urlscript' => 'Nette\Http\UrlScript',
		'nurlscript' => 'Nette\Http\UrlScript',
		'ioexception' => 'Nette\IOException',
		'invalidargumentexception' => 'Nette\InvalidArgumentException',
		'ninvalidargumentexception' => 'Nette\InvalidArgumentException',
		'invalidstateexception' => 'Nette\InvalidStateException',
		'ninvalidstateexception' => 'Nette\InvalidStateException',
		'htmlnode' => 'Nette\Latte\HtmlNode',
		'nhtmlnode' => 'Nette\Latte\HtmlNode',
		'imacro' => 'Nette\Latte\IMacro',
		'macronode' => 'Nette\Latte\MacroNode',
		'nmacronode' => 'Nette\Latte\MacroNode',
		'macrotokenizer' => 'Nette\Latte\MacroTokenizer',
		'nmacrotokenizer' => 'Nette\Latte\MacroTokenizer',
		'cachemacro' => 'Nette\Latte\Macros\CacheMacro',
		'ncachemacro' => 'Nette\Latte\Macros\CacheMacro',
		'coremacros' => 'Nette\Latte\Macros\CoreMacros',
		'ncoremacros' => 'Nette\Latte\Macros\CoreMacros',
		'formmacros' => 'Nette\Latte\Macros\FormMacros',
		'nformmacros' => 'Nette\Latte\Macros\FormMacros',
		'macroset' => 'Nette\Latte\Macros\MacroSet',
		'nmacroset' => 'Nette\Latte\Macros\MacroSet',
		'uimacros' => 'Nette\Latte\Macros\UIMacros',
		'nuimacros' => 'Nette\Latte\Macros\UIMacros',
		'parser' => 'Nette\Latte\Parser',
		'nparser' => 'Nette\Latte\Parser',
		'phpwriter' => 'Nette\Latte\PhpWriter',
		'nphpwriter' => 'Nette\Latte\PhpWriter',
		'memberaccessexception' => 'Nette\MemberAccessException',
		'nmemberaccessexception' => 'Nette\MemberAccessException',
		'notimplementedexception' => 'Nette\NotImplementedException',
		'nnotimplementedexception' => 'Nette\NotImplementedException',
		'notsupportedexception' => 'Nette\NotSupportedException',
		'nnotsupportedexception' => 'Nette\NotSupportedException',
		'outofrangeexception' => 'Nette\OutOfRangeException',
		'noutofrangeexception' => 'Nette\OutOfRangeException',
		'staticclassexception' => 'Nette\StaticClassException',
		'nstaticclassexception' => 'Nette\StaticClassException',
		'unexpectedvalueexception' => 'Nette\UnexpectedValueException',
		'nunexpectedvalueexception' => 'Nette\UnexpectedValueException',
		'unknownimagefileexception' => 'Nette\UnknownImageFileException',
		'nunknownimagefileexception' => 'Nette\UnknownImageFileException',
		'arrays' => 'Nette\Utils\Arrays',
		'narrays' => 'Nette\Utils\Arrays',
		'strings' => 'Nette\Utils\Strings',
		'nstrings' => 'Nette\Utils\Strings',

		// old classes
		'presenterloader' => 'Nette\Application\PresenterFactory',
		'npresenterloader' => 'Nette\Application\PresenterFactory',
		'conventionalrenderer' => 'Nette\Forms\Rendering\DefaultFormRenderer',
		'nconventionalrenderer' => 'Nette\Forms\Rendering\DefaultFormRenderer',
		'inamingcontainer' => 'Nette\Forms\INamingContainer',
		'tools' => 'Nette\Tools',
		'ntools' => 'Nette\Tools',
		'downloadresponse' => 'Nette\Application\Responses\FileResponse',
		'ndownloadresponse' => 'Nette\Application\Responses\FileResponse',
		'forwardingresponse' => 'Nette\Application\Responses\ForwardResponse',
		'nforwardingresponse' => 'Nette\Application\Responses\ForwardResponse',
		'multirouter' => 'Nette\Application\Routers\RouteList',
		'nmultirouter' => 'Nette\Application\Routers\RouteList',
		'redirectingresponse' => 'Nette\Application\Responses\RedirectResponse',
		'nredirectingresponse' => 'Nette\Application\Responses\RedirectResponse',
		'renderresponse' => 'Nette\Application\Responses\TextResponse',
		'nrenderresponse' => 'Nette\Application\Responses\TextResponse',
		'arraytools' => 'Nette\Utils\Arrays',
		'narraytools' => 'Nette\Utils\Arrays',
		'dummystorage' => 'Nette\Caching\Storages\DevNullStorage',
		'ndummystorage' => 'Nette\Caching\Storages\DevNullStorage',
		'debug' => 'Nette\Diagnostics\Debugger',
		'ndebug' => 'Nette\Diagnostics\Debugger',
		'fileupload' => 'Nette\Forms\Controls\UploadControl',
		'nfileupload' => 'Nette\Forms\Controls\UploadControl',
		'string' => 'Nette\Utils\Strings',
		'nstring' => 'Nette\Utils\Strings',
		'lattemacros' => 'Nette\Templates\LatteMacros',
		'nlattemacros' => 'Nette\Templates\LatteMacros',
		'templatecachestorage' => 'Nette\Caching\Storages\PhpFileStorage',
		'ntemplatecachestorage' => 'Nette\Caching\Storages\PhpFileStorage',
		'sessionnamespace' => 'Nette\Http\SessionSection',
		'nsessionnamespace' => 'Nette\Http\SessionSection',
		'uri' => 'Nette\Http\Url',
		'nuri' => 'Nette\Http\Url',
		'uriscript' => 'Nette\Http\UrlScript',
		'nuriscript' => 'Nette\Http\UrlScript',
		'context' => 'Nette\DI\Container',
		'ncontext' => 'Nette\DI\Container',
		'debugpanel' => 'Nette\Diagnostics\DefaultBarPanel',
		'ndebugpanel' => 'Nette\Diagnostics\DefaultBarPanel',
		'icontext' => 'Nette\DI\IContainer',
		'idebugpanel' => 'Nette\Diagnostics\IBarPanel',
	);



	public function run($folder)
	{
		set_time_limit(0);

		if ($this->readOnly) {
			echo "Running in read-only mode\n";
		}

		echo "Scanning folder $folder...\n";

		$counter = 0;
		foreach (Nette\Utils\Finder::findFiles('*.php')->from($folder)
			->exclude(array('.*', '*.tmp', 'tmp', 'temp', 'log')) as $file)
		{
			echo str_pad(str_repeat('.', $counter++ % 40), 40), "\x0D";
			$name = ltrim(str_replace($folder, '', $file), '/\\');

			try {
				$orig = file_get_contents($file);
				$new = $this->processFile($orig);
				if ($new !== $orig) {
					echo '[' . ($this->readOnly ? 'FOUND' : 'FIX') . "] $name\n";
					if (!$this->readOnly) {
						file_put_contents($file, $new);
					}
				}
			} catch (Exception $e) {
				echo "[SKIP] $name: {$e->getMessage()}\n";
			}
		}

		echo "\nDone.";
	}



	public function processFile($input)
	{
		$parser = new PhpParser($input);
		while (($token = $parser->fetch()) !== FALSE) {

			if ($parser->isCurrent(T_NAMESPACE, T_USE)) {
				throw new Exception('PHP 5.3 file');

			} elseif ($parser->isCurrent(T_INSTANCEOF, T_EXTENDS, T_IMPLEMENTS, T_NEW)) {
				do {
					$parser->fetchAll(T_WHITESPACE, T_COMMENT);
					$pos = $parser->position + 1;
					if ($class = $parser->fetchAll(T_STRING, T_NS_SEPARATOR)) {
						$parser->replace($this->renameClass($class), $pos);
					}
				} while ($class && $parser->fetch(','));

			} elseif ($parser->isCurrent(T_STRING, T_NS_SEPARATOR)) { // Class:: or typehint
				$pos = $parser->position;
				$identifier = $token . $parser->fetchAll(T_STRING, T_NS_SEPARATOR);
				if ($parser->isNext(T_DOUBLE_COLON, T_VARIABLE)) {
					$parser->replace($this->renameClass($identifier), $pos);
				}

			} elseif ($parser->isCurrent(T_DOC_COMMENT, T_COMMENT)) {
				// @var Class or \Class or Nm\Class or Class:: (preserves CLASS)
				$that = $this;
				$parser->replace(preg_replace_callback('#((?:@var(?:\s+array of)?|returns?|param|throws|@link|property[\w-]*)\s+)([\w\\\\|]+)#', function($m) use ($that) {
					$parts = array();
					foreach (explode('|', $m[2]) as $part) {
						$parts[] = preg_match('#^\\\\?[A-Z].*[a-z]#', $part) ? $that->renameClass($part) : $part;
					}
					return $m[1] . implode('|', $parts);
				}, $token));

			} elseif ($parser->isCurrent(T_CONSTANT_ENCAPSED_STRING)) {
				if (preg_match('#(^.)([A-Z]\w*[a-z]\w*)(:.*|.\z)#', $token, $m)) { // 'NObject'
					$class = str_replace('\\\\', '\\', $m[2], $double);
					if (isset($that->replaces[strtolower($class)])) {
						$class = $that->replaces[strtolower($class)];
						$parser->replace($m[1] . str_replace('\\', $double ? '\\\\' : '\\', $class) . $m[3]);
					}
				}
			}
		}

		$parser->position = 0;
		return $parser->fetchAll();
	}



	/**
	 * Renames class.
	 * @param  string class
	 * @return string new class
	 */
	function renameClass($class)
	{
		return isset($this->replaces[strtolower($class)]) ? $this->replaces[strtolower($class)] : $class;
	}

}



/**
 * Simple tokenizer for PHP.
 */
class PhpParser extends Nette\Utils\Tokenizer
{

	function __construct($code)
	{
		$this->ignored = array(T_COMMENT, T_DOC_COMMENT, T_WHITESPACE);
		foreach (token_get_all($code) as $token) {
			$this->tokens[] = is_array($token) ? self::createToken($token[1], $token[0]) : $token;
		}
	}



	function replace($s, $start = NULL)
	{
		for ($i = ($start === NULL ? $this->position : $start) - 1; $i < $this->position - 1; $i++) {
			$this->tokens[$i] = '';
		}
		$this->tokens[$this->position - 1] = $s;
	}

}



$updater = new ClassUpdater;
$updater->readOnly = !isset($options['f']);
$updater->run(isset($options['d']) ? $options['d'] : getcwd());
